#include <tic.h>

#ifdef MEMORY_SHARED
  static __tic_lock_t mutex[ 2 ] = 
   { __tic_lock_decl_initializer, __tic_lock_decl_initializer };

  #define MULTIPLE_THREADS
  #define ACQUIRE_DTOA_LOCK( n )  __tic_lock(   &mutex[ n ] )
  #define FREE_DTOA_LOCK( n )     __tic_unlock( &mutex[ n ] )
#endif


#include "../../fp-utils/dtoa-common.c"
