#ifndef _tc_hash_map_h_
#define _tc_hash_map_h_

#if HAVE_HASH_MAP
#include <hash_map>
#define POINTER_HASH_MAP(keyT, valueT) hash_map< intptr_t, valueT >
#define HASH_MAP(keyT, valueT) hash_map< keyT, valueT >
#elif defined(HAVE_EXT_HASH_MAP)
#include <ext/hash_map>
#define POINTER_HASH_MAP(keyT, valueT) hash_map< intptr_t, valueT >
#define HASH_MAP(keyT, valueT) hash_map< keyT, valueT >
#else
#include <map>
#define POINTER_HASH_MAP(keyT, valueT) map< intptr_t, valueT >
#define HASH_MAP(keyT, valueT) map< keyT, valueT >
#endif

#endif
