/* May be included multiple times */

#undef INLINE_MODIFIER
#undef INLINE_MODIFIER_FOR_SOLARIS_AM
#undef STATIC_INLINE
#undef FORCE_NO_RUNTIME_INLINE

/* user-requested defaults */
#include "config.h"

/* capabilities known to be absent from specific compilers */

/* Sun WorkShop Pro */
#ifdef __SUNPRO_C
# define FORCE_NO_RUNTIME_INLINE
#endif

#if STATIC_INLINE_WORKS
#define STATIC_INLINE static inline
#else
#define STATIC_INLINE static
#endif

/* Inline modifier: If we are inlining then use "static inline" if
   possible, but otherwise use inline or __inline, or on compilers with no
   inline keyword, static.  If we are not inlining then use static or
   nothing at all, depending on whether FORCE_STATIC is true. */
#if defined(USE_RUNTIME_INLINE) && !defined(FORCE_NO_RUNTIME_INLINE)
#if defined(_AIX) && !defined(__GNUC__)
#  define INLINE_MODIFIER __inline
#else
#  define INLINE_MODIFIER_FOR_SOLARIS_AM inline
#  define INLINE_MODIFIER STATIC_INLINE
#endif
#else /* USE_RUNTIME_INLINE && !FORCE_NO_RUNTIME_INLINE */
#define INLINE_MODIFIER_FOR_SOLARIS_AM
#if FORCE_STATIC || !defined(USE_RUNTIME_INLINE)
#  define INLINE_MODIFIER static
#else
#  define INLINE_MODIFIER
#endif
#endif /* USE_RUNTIME_INLINE && !FORCE_NO_RUNTIME_INLINE */

